// ACM 2006
// Problem A. Automaton optimization
// Sergio A. Fjodorov

//  -    ,    ,
//     fedorov@msun.ru -   !!! :)

{$apptype console}

uses
  Math;

var
  t: array[1..2000] of integer;
  tc: integer;
  tt: integer;
  w: array[-1000..1000] of boolean;
  a: array[0..2000] of boolean;
  i, j, n: integer;
  s, f, l: integer;
  p: integer;

begin
  Assign(input, 'input.txt');
  Assign(output, 'output.txt');
  Reset(input);
  Rewrite(output);

  FillChar(w, sizeof(w), false);
  tc := 0;

  // 
  Read(n);
  for i := 0 to n - 1 do begin
    Read(tt);
    if w[tt] then continue;
    w[tt] := true;
    Inc(tc);
    t[tc] := tt;
  end;
  Read(s, f, l);

  Dec(s); //   - s = 0

  for i := 1 to tc do begin
    for j := 0 to l - 1 do begin
      p := f + j - t[i]; //   
      if p < 0 then p := -p;

      if (s - p) mod 2 <> 0 then continue; //   - 

      p := (s - p) div 2;
      a[j] := a[j] xor (p and (s - p) = 0);
    end;
  end;

  Write(integer(a[0]));
  for i := 1 to l - 1 do
    Write(' ', integer(a[i]));
  WriteLn;

  Close(input);
  Close(output);
end.
