{$apptype console}
// (C) Chistyakov T. S. 2006

uses
  SysUtils;
  
function get(startcol, line, col: integer): integer;

  function get2(size, startcol, line: integer): integer;
  begin
    //     
    if (col < startcol - line)  or (col > startcol + line) then begin
      Result := 0;
      Exit;
    end;
    if size = 1 then begin
      Result := 1;
      Exit;
    end;

    if line < size div 2 then
      //  
      Result := get2(size div 2, startcol, line)
    else if col - startcol < 0 then
      //  
      Result :=
        get2(size div 2, startcol - size div 2, line - size div 2)
    else
      //  
      Result :=
        get2(
          size div 2, startcol + size div 2, line - size div 2);
  end;

var
  size: integer;
begin
  size := 1;
  while line >= size do
    size := size * 2;
  Result := get2(size, startcol, line);
end;


var 
  fi, fo: textfile;
  ones: array of integer;
  n, s, f, l: integer;
  i, j: integer;
  r: integer;
begin
  assignfile(fi, 'input.txt');
  reset(fi);
  assignfile(fo, 'output.txt');
  rewrite(fo);
  try
    read(fi, n);
    assert((n >= 1) and (n <= 2000));
    setlength(ones, n);
    for i := 0 to n - 1 do begin
      read(fi, ones[i]);
      assert((ones[i] >= -1000) and (ones[i] <= 1000));
      for j := 0 to i - 1 do
        assert(ones[j] <> ones[i]);
    end;
    read(fi, s, f, l);
    assert((l >= 1) and (l <= 2000));
    assert((s >= 1) and (s <= 1000000000));
    assert((f >= -1000000000) and (f <= 1000000000));

    for i := f to f + l - 1 do begin
      r := 0;
      for j := 0 to n - 1 do
        r := r + get(ones[j], s - 1, i);
      write(fo, r mod 2, ' ');
    end;
  finally
    closefile(fi);
    closefile(fo);
  end;
end.