{$apptype console}
// (C) Chistyakov T. S. 2006

function get(startcol, line, col: integer): integer;

  function get2(size, startcol, line: integer): integer;
  begin
    //     
    if (col < startcol - line)  or (col > startcol + line) then begin
      Result := 0;
      Exit;
    end;
    if size = 1 then begin
      Result := 1;
      Exit;
    end;

    if line < size div 2 then
      //  
      Result := get2(size div 2, startcol, line)
    else if col - startcol < 0 then
      //  
      Result :=
        get2(size div 2, startcol - size div 2, line - size div 2)
    else
      //  
      Result :=
        get2(
          size div 2, startcol + size div 2, line - size div 2);
  end;

var
  size: integer;
begin
  size := 1;
  while line >= size do
    size := size * 2;
  Result := get2(size, startcol, line);
end;


var 
  fi, fo: textfile;
  ones: array of integer;
  n, s, f, l: integer;
  i, j, k: integer;
  r: integer;
begin
  assignfile(fi, 'input.txt');
  reset(fi);
  assignfile(fo, 'output.txt');
  rewrite(fo);
  try
    read(fi, n);
    setlength(ones, n);
    for i := 0 to n - 1 do
      read(fi, ones[i]);
    read(fi, s, f, l);

    for k := 1 to s do begin
      write(fo, k:5, ' ');
      for i := f to f + l - 1 do begin
        r := 0;
        for j := 0 to n - 1 do
          r := r + get(ones[j], k - 1, i);
        if r mod 2 = 0 then
          write(fo, '.')
        else
          write(fo, '#');
      end;
      writeln(fo);
    end;
  finally
    closefile(fi);
    closefile(fo);
  end;
end.